## speedcrunch 0.12.0

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(speedcrunch)
set(speedcrunch_VERSION "0.12")

set(CMAKE_AUTOMOC ON)
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE OFF)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5Core)
find_package(Qt5Widgets)
find_package(Qt5Help)

if(APPLE)
    set(PROGNAME SpeedCrunch)
    set(MACOSX_BUNDLE_ICON_FILE speedcrunch.icns)
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${speedcrunch_VERSION})
    set(MACOSX_BUNDLE_VERSION ${speedcrunch_VERSION})
    set(MACOSX_BUNDLE_LONG_VERSION_STRING Version ${speedcrunch_VERSION})
    set(CMAKE_OSX_ARCHITECTURES ppc;i386)
else(APPLE)
    set(PROGNAME speedcrunch)
endif(APPLE)

ADD_DEFINITIONS("-DSPEEDCRUNCH_VERSION=\"${speedcrunch_VERSION}\"")
ADD_DEFINITIONS(-DQT_USE_QSTRINGBUILDER)

include(SourceFiles.cmake)

if(WIN32)
    set(WIN32_RES_FILE ${CMAKE_CURRENT_BINARY_DIR}/speedcrunch.rc.obj)
    if(MINGW)
        add_custom_command(OUTPUT ${WIN32_RES_FILE}
                           COMMAND windres.exe ${CMAKE_CURRENT_SOURCE_DIR}/resources/speedcrunch.rc ${WIN32_RES_FILE})
    else(MINGW)
        add_custom_command(OUTPUT ${WIN32_RES_FILE}
                           COMMAND rc.exe /fo ${WIN32_RES_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/resources/speedcrunch.rc)
    endif(MINGW)
endif(WIN32)

string(COMPARE EQUAL "${CMAKE_CXX_COMPILER_ID}" MSVC USING_MSVC)
if(USING_MSVC)
    add_definitions(-D_USE_MATH_DEFINES)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
else()
    add_definitions(-Wall)
    add_definitions(-Wno-shift-negative-value)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
endif()

# Embedded manual
option(REBUILD_MANUAL "Rebuild the manual rather than using the bundled copy" FALSE)
add_subdirectory(../doc/src doc)
if(REBUILD_MANUAL)
    # set here so CMake knows about this file in this CMakeLists
    set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/doc/manual.qrc PROPERTY GENERATED true)
    set(speedcrunch_RESOURCES ${speedcrunch_RESOURCES} ${CMAKE_CURRENT_BINARY_DIR}/doc/manual.qrc)
else()
    set(speedcrunch_RESOURCES ${speedcrunch_RESOURCES} ${CMAKE_CURRENT_SOURCE_DIR}/../doc/build_html_embedded/manual.qrc)
endif()

qt5_add_RESOURCES(speedcrunch_RESOURCES_SOURCES ${speedcrunch_RESOURCES})
add_executable(${PROGNAME} WIN32 MACOSX_BUNDLE ${speedcrunch_SOURCES} ${speedcrunch_HEADERS_MOC} ${speedcrunch_RESOURCES_SOURCES} ${speedcrunch_FORMS_HEADERS} ${WIN32_RES_FILE})

if(REBUILD_MANUAL)
    add_dependencies(${PROGNAME} manual)
endif()

if(APPLE)
    set( speedcrunch_RESOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/${PROGNAME}.app/Contents/Resources )
    add_custom_command(TARGET ${PROGNAME} POST_BUILD
                       COMMAND mkdir ARGS -p ${speedcrunch_RESOURCE_DIR}
                       COMMAND cp ARGS -f resources/${MACOSX_BUNDLE_ICON_FILE} ${speedcrunch_RESOURCE_DIR})
endif(APPLE)

add_custom_target(confclean COMMAND rm -rf Makefile CMakeFiles/ CMakeCache.txt cmake_install.cmake DartTestfile.txt install_manifest.txt)

set(QT_LIBRARIES Qt5::Widgets Qt5::Help)
target_link_libraries(${PROGNAME} ${QT_LIBRARIES})

enable_testing()

add_executable(testhmath ${testhmath_SOURCES})
target_link_libraries(testhmath ${QT_LIBRARIES})
add_test(testhmath testhmath)

add_executable(testevaluator ${testevaluator_SOURCES} ${testevaluator_HEADERS_MOC})
target_link_libraries(testevaluator ${QT_LIBRARIES})
add_test(testevaluator testevaluator)

add_executable(testfloatnum ${testfloatnum_SOURCES})
add_test(testfloatnum testfloatnum)

add_executable(testcmath ${testcmath_SOURCES})
target_link_libraries(testcmath ${QT_LIBRARIES})
add_test(testcmath testcmath)

add_executable(testdmath ${testdmath_SOURCES})
target_link_libraries(testdmath ${QT_LIBRARIES})
add_test(testdmath testdmath)

add_executable(testser ${testser_SOURCES})
target_link_libraries(testser ${QT_LIBRARIES})
add_test(testser testser)

set_property(TARGET ${PROGNAME} APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:Debug>:EVALUATOR_DEBUG>)

include_directories(${CMAKE_BINARY_DIR} thirdparty core gui math)

################################# INSTALL ######################################

if(NOT WIN32)
    set(SHAREDIR "share/")
    set(MENUDIR "${SHAREDIR}/applications/")
    set(APPDATADIR "${SHAREDIR}/appdata/")
    set(ICONDIR "${SHAREDIR}/pixmaps/")
    set(BINDIR "bin")
else(NOT WIN32)
    set(BINDIR ".")
    set(DATADIR ".")
endif(NOT WIN32)

option(PORTABLE_SPEEDCRUNCH "Enable to build in portable mode" OFF)
if(PORTABLE_SPEEDCRUNCH)
    add_definitions(-DSPEEDCRUNCH_PORTABLE)
endif(PORTABLE_SPEEDCRUNCH)

install(TARGETS ${PROGNAME} DESTINATION ${BINDIR})

if(NOT WIN32)
    install(FILES ../pkg/speedcrunch.desktop DESTINATION ${MENUDIR})
    install(FILES resources/speedcrunch.png DESTINATION ${ICONDIR})
    install(FILES ../pkg/speedcrunch.appdata.xml DESTINATION ${APPDATADIR})
else(NOT WIN32)
    install(FILES ../pkg/COPYING.rtf DESTINATION ${DATADIR})
endif(NOT WIN32)

if(WIN32)
    include(../pkg/QtWin32Deploy.cmake)
    qtwin32_deploy_modules(${BINDIR} qtwin32_Qt5Widgets qtwin32_Qt5Help)
    qtwin32_deploy_default_qt_conf(${BINDIR})
    if(${qtwin32_QT_MINOR_VERSION} VERSION_LESS 5.5)
        # Qt 5.4 and below also require ICU.
        qtwin32_deploy_modules(${BINDIR} qtwin32_ICU)
    endif()
endif(WIN32)
set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ${BINDIR})
include(InstallRequiredSystemLibraries)

################################# PACKAGE #####################################

set(CPACK_PACKAGE_VENDOR SpeedCrunch)
set(CPACK_PACKAGE_VERSION ${speedcrunch_VERSION})
set(CPACK_PACKAGE_INSTALL_DIRECTORY SpeedCrunch)
set(CPACK_PACKAGE_EXECUTABLES ${PROGNAME} SpeedCrunch)

if(WIN32)
    if(NOT CPACK_GENERATOR)
        if(PORTABLE_SPEEDCRUNCH)
            set(CPACK_GENERATOR ZIP)
        else(PORTABLE_SPEEDCRUNCH)
            set(CPACK_GENERATOR NSIS)
        endif(PORTABLE_SPEEDCRUNCH)
    endif(NOT CPACK_GENERATOR)

    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../pkg/COPYING.rtf")
    set(CPACK_NSIS_EXECUTABLES_DIRECTORY ${BINDIR})
    set(CPACK_NSIS_INSTALLED_ICON_NAME "${BINDIR}\\\\${PROGNAME}.exe,0")
    set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\resources\\\\speedcrunch.ico")
    set(CPACK_NSIS_HELP_LINK "http://groups.google.com/group/speedcrunch")
    set(CPACK_NSIS_URL_INFO_ABOUT "http://speedcrunch.org")
    set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL true)

    set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS
        "WriteRegStr SHCTX 'Software\\\\RegisteredApplications' 'SpeedCrunch' 'Software\\\\SpeedCrunch\\\\Capabilities'
         WriteRegStr SHCTX 'Software\\\\SpeedCrunch\\\\Capabilities' 'ApplicationDescription' 'SpeedCrunch is a high-precision scientific calculator'
         WriteRegStr SHCTX 'Software\\\\SpeedCrunch\\\\Capabilities' 'ApplicationName' 'SpeedCrunch'
         WriteRegStr SHCTX 'Software\\\\SpeedCrunch\\\\Capabilities\\\\UrlAssociations' 'calculator' 'SpeedCrunch.Url.calculator'

         WriteRegStr SHCTX 'Software\\\\Classes\\\\SpeedCrunch.Url.calculator' '' 'SpeedCrunch'
         WriteRegStr SHCTX 'Software\\\\Classes\\\\SpeedCrunch.Url.calculator' 'FriendlyTypeName' 'SpeedCrunch'
         WriteRegStr SHCTX 'Software\\\\Classes\\\\SpeedCrunch.Url.calculator\\\\shell\\\\open\\\\command' '' '\\\"$INSTDIR\\\\${BINDIR}\\\\${PROGNAME}.exe\\\"'
         WriteRegStr SHCTX 'Software\\\\Classes\\\\SpeedCrunch.Url.calculator\\\\Application' 'ApplicationCompany' 'SpeedCrunch'

         WriteRegStr SHCTX 'Software\\\\Classes\\\\Applications\\\\${PROGNAME}.exe' 'FriendlyAppName' 'SpeedCrunch'
         ")
    set(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS
        "DeleteRegValue SHCTX 'Software\\\\RegisteredApplications' 'SpeedCrunch'
         DeleteRegKey SHCTX 'Software\\\\SpeedCrunch'
         DeleteRegKey SHCTX 'Software\\\\Classes\\\\SpeedCrunch.Url.calculator'
         DeleteRegKey SHCTX 'Software\\\\Classes\\\\Applications\\\\${PROGNAME}.exe'
         ")

    if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        # When building a 64-bit installer, we add a check to make it fail on 32-bit systems
        # because CPack doesn't do that by itself. Using this variable is probably a bit of a hack
        # though.
        set(CPACK_NSIS_DEFINES
            "!include 'x64.nsh'
             Function x64Check
             \\\${IfNot} \\\${RunningX64}
                 MessageBox MB_OK|MB_ICONEXCLAMATION 'This installer can only be run on 64-bit Windows.'
                 Quit
             \\\${EndIf}
             FunctionEnd

             Page custom x64Check
            ")
    endif()
endif(WIN32)

include(CPack)

################################ UNINSTALL #####################################

configure_file( "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
                IMMEDIATE @ONLY)

add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== doc/src/CMakeLists.txt ===
file(GLOB_RECURSE doc_RST *.rst)
file(GLOB_RECURSE doc_PO *.po)
list(APPEND doc_depends
    ${doc_RST}
    ${doc_PO}
    conf.py
    doc-tool.py)


# find Python
find_package(PythonInterp 3.4 QUIET)

# get a path for qcollectiongenerator
find_package(Qt5Help)

if(TARGET Qt5::qcollectiongenerator)
    # The Qt5::qcollectiongenerator imported target was added in Qt 5.3, but it tells us exactly where
    # qcollectiongenerator is.
    get_target_property(qcg Qt5::qcollectiongenerator LOCATION)
    get_filename_component(qt_bin_dir ${qcg} DIRECTORY)
else()
    # "Next to qmake" is probably correct.
    get_target_property(qmake Qt5::qmake LOCATION)
    get_filename_component(qt_bin_dir ${qmake} DIRECTORY)
endif()

find_program(
    QCOLLECTIONGENERATOR_EXECUTABLE
    NAMES qcollectiongenerator
    HINTS ${qt_bin_dir})

# get a path for sphinx-build
if(WIN32)
    get_filename_component(python_dir ${PYTHON_EXECUTABLE} DIRECTORY)
    # on Windows, there's a good chance Sphinx is in the Python installation we found
    set(extra_sphinx_paths ${python_dir}/Scripts)
endif()

find_program(
    SPHINX_EXECUTABLE
    NAMES sphinx-build
    PATHS ${extra_sphinx_paths})


set(DOCTOOL_EXECUTABLE ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/doc-tool.py")
set(DOCTOOL_COMMAND ${DOCTOOL_EXECUTABLE}
                    --sphinx-build-binary="${SPHINX_EXECUTABLE}"
                    --qcollectiongenerator-binary=${QCOLLECTIONGENERATOR_EXECUTABLE}
                    --source-dir="${CMAKE_CURRENT_SOURCE_DIR}")


# command for auto-building the manual when building SpeedCrunch with REBUILD_MANUAL --
# this only works in the build directory and does not touch the prebuilt copy in the
# source tree
add_custom_command(
    OUTPUT manual.qrc
    COMMAND ${DOCTOOL_COMMAND}
            build-bundled-docs --build-dir="${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${doc_depends})
add_custom_target(manual DEPENDS manual.qrc)


# command for updating the prebuilt manual in the source; invoke manually (hah)
# via `make update-prebuilt-manual`
set(PREBUILT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../build_html_embedded")
add_custom_command(
    OUTPUT tgt_update-prebuilt-manual
    COMMENT "Rebuilding bundled prebuilt docs..."
    COMMAND ${CMAKE_COMMAND} -E remove_directory "${PREBUILT_DIR}"
    COMMAND ${DOCTOOL_COMMAND} build-bundled-docs --build-dir="${PREBUILT_DIR}")
add_custom_target(update-prebuilt-manual DEPENDS tgt_update-prebuilt-manual)
set_property(SOURCE tgt_update-prebuilt-manual PROPERTY SYMBOLIC)

=== doc/src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS   =
SPHINXBUILD  = sphinx-build
SOURCEDIR    = .
BUILDDIR     = _build

# Has to be explicit, otherwise we don't get "make" without targets right.
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%:
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
speedcrunch (0.12.0-8) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.
  * debian/control: Update Vcs-* fields.
  * debian/patches:
    - 0009-Fix-CMakeLists-cmake_minimum_required.patch: Add <max> version to
      cmake_minimum_required.
    - 0010-Fix-CMakeLists-Find-Python3.patch: Fix the way to find Python 3.
      The old was deprecated.
    - This two patches closes: #1113535.

 -- Marcos Talau <talau@debian.org>  Sat, 01 Nov 2025 17:46:34 -0300

speedcrunch (0.12.0-7) experimental; urgency=medium

  * QA upload.
  * debian/copyright: Update packaging copyright information.
  * debian/upstream/metadata: Add upstream metadata information.

 -- Rony João de Sousa <ronyjdesousa@gmail.com>  Sun, 04 May 2025 04:47:14 -0300

speedcrunch (0.12.0-6) unstable; urgency=medium

  * d/patches: use Sphinx built-in i18n support for extensions
    - Closes: #1026816

 -- Felix Krull <f_krull@gmx.de>  Fri, 23 Dec 2022 19:24:30 +0100

speedcrunch (0.12.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix docs build with Sphinx >= 4. (Closes: #997366)
    - Add 0007-fix-docs-build-with-Sphinx-4.patch

 -- Felix Geyer <fgeyer@debian.org>  Sat, 29 Oct 2022 09:59:26 +0200

speedcrunch (0.12.0-5) unstable; urgency=medium

  * d/patches, d/control: fix docs build with Sphinx >= 2.0
    - Closes: #955058
  * d/patches: use CMake's CXX_STANDARD property
  * d/copyright: add separate notice for appdata files
  * d/control:
    - bump Standards-Version
    - bump debhelper compat version

 -- Felix Krull <f_krull@gmx.de>  Sun, 19 Apr 2020 14:13:08 +0200

speedcrunch (0.12.0-4) unstable; urgency=medium

  * d/control:
    - update VCS-* urls
    - bump Standards-Version
    - use python3-sphinx instead of python-sphinx
  * d/compat: bump debhelper compat version to 10
  * d/patches, d/rules: build the HTML manual in a separate step
    - Rebuilding the HTML manual during the build has proven fragile. Instead,
      the manual is now built in a separate step and the application build is
      pointed at the result of that build.
    - Closes: #897531

 -- Felix Krull <f_krull@gmx.de>  Mon, 14 May 2018 16:52:42 +0000

speedcrunch (0.12.0-3) unstable; urgency=medium

  * debian/patches: clean up build system fixes
    - Replaced several disjointed cherry-picked changes with a copy of the
      current upstream CMake files, to prevent more backporting mistakes.
    - Closes: #872053
  * debian/patches: fix docs build with Sphinx 1.5
  * debian/control: bump Standards-Version

 -- Felix Krull <f_krull@gmx.de>  Sat, 26 Aug 2017 17:53:01 +0000

speedcrunch (0.12.0-2) unstable; urgency=medium

  * debian/patches:
     - Backport some docs build fixes (closes: #871207).
     - Install appdata file into new metadata path
  * debian/copyright: use https:// for Format URL.
  * debian/control:
     - Update VCS url.
     - Bump Standards-Version.
     - Specify minimum CMake version in Build-Depends.

 -- Felix Krull <f_krull@gmx.de>  Mon, 07 Aug 2017 14:56:19 +0000

speedcrunch (0.12.0-1) unstable; urgency=medium

  * New upstream release 0.12.
  * debian/control:
    - Update build dependencies to Qt 5.
    - Add dependencies for building the manual.
  * debian/patches: remove outdated patches.
  * debian/gbp.conf: remove upstream tag format.
  * debian/watch: update for new upstream download location and tag format.
  * debian/rules: rebuild the manual during build.
  * debian/patches/0001-Fix-docs-build-rebuild.patch: Fix building the manual
    from source.
  * debian/copyright: update copyrights.
  * debian/source/lintian-overrides: override errors about JS files in
    prebuilt manual; lintian doesn't notice the source right next to it.
  * debian/clean: remove docs build debris.

 -- Felix Krull <f_krull@gmx.de>  Fri, 02 Dec 2016 21:37:44 +0000

=== debian/control ===
Source: speedcrunch
Section: math
Priority: optional
Maintainer: Felix Krull <f_krull@gmx.de>
Build-Depends: debhelper-compat (= 12),
               qtbase5-dev (>= 5.2), qttools5-dev (>= 5.2),
               qttools5-dev-tools (>= 5.2), libqt5sql5-sqlite,
               cmake (>= 3.1), python3 (>= 3.4), python3-sphinx (>= 1.3),
               python3-sphinxcontrib.qthelp,
               python3-quark-sphinx-theme (>= 0.2),
               docbook2x, imagemagick
Standards-Version: 4.5.0
Rules-Requires-Root: binary-targets
Homepage: http://www.speedcrunch.org/
Vcs-Git: https://salsa.debian.org/debian/speedcrunch.git
Vcs-Browser: https://salsa.debian.org/debian/speedcrunch

Package: speedcrunch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite
Description: High precision calculator
 SpeedCrunch is a high precision and high speed calculator.
 .
 It's optimized for keyboard use and has advanced features: use of functions,
 use of variables, result history, and syntax highlighting. It also shows the
 result as you type.
 .
 SpeedCrunch has a very simple interface, so you can start to use it very
 quickly.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

docs:
	mkdir -p build-docs
	cd build-docs && cmake ../doc/src
	make -C build-docs

override_dh_auto_configure: docs
	dh_auto_configure -- -DHTML_DOCS_DIR=../build-docs

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1
	docbook2x-man debian/speedcrunch.1.docbook
	convert -resize 32x32 src/resources/speedcrunch.png speedcrunch.xpm
